/********************************************/
/*	FLUKE 87IVfW^}`[^ IrDAʐM	*/
/********************************************/
//	"fluke87_irda_tn841.c"  Created: 2022/06/29 14:10:31
//	2022-11-15	MCP2122,TIR1000JP1Ő؂ւł悤
//				IrDAւ̑M̎IrDAM֎~ 1
//	IrDA  USB ʐMc[
//  87IVeX^[  PCUSB
//	IrDAfR[_ MCP2122邢TIR1000𐧌
//	MCP2122LŃZbg  TIR1000HŃZbg
//	TIR1000ɂ͑MɎM֎~@\
//	IrDAW[ Hdq AE-RPM851A
//	c[   : Atmel Studio 7 (V 7.0.1645)
//	}CR : ATtiny841 (14pin)
//	OtXTAL : 4.9152MHz
//	Fuse X = 0xFF
//		 H = 0xDC	1101 1100 
//					|||| |+++--- BOD 4.3V
//					|||| +------ EESAVE
//					|||+-------- WDTON
//					||+--------- SPIEN  (l0)
//					|+---------- DWEN
//					+----------- RSTDISBL
//		 L = 0xCD	1100 1101
//					|| | ++++--- CKSEL XATL 3`8MHz
//					|| +-------- SUT   16k clk
//					|+---------- SKOUT
//					+----------- CKDIV8  1/1
//	|[g
//		PA0 in  JP1  Wp[  on:MCP2122,off:TIR1000
//		PA1 out TX0  IrDA   (MCP2122,TIR1000)
//		PA2 in  RX0  IrDA
//		PA3 out TO2  OC0B 153.6kHz clko
//		PA4 in  RX0  USB (PC)
//		PA5 out TX1  USB
//		PA6 out (MOSI) eXgpX CloopŃgO
//		PA7 out -      eXgpX
//		PB0 -   X1  4.9152MHz
//		PB1 -   X2  XTAL
//		PB2 out MCP2122ZbgMo LŃZbg (TIR1000͋t)
//		PB3 in  /RESET
//	^C}[0  OC0B153.6kHzo
//	^C}[1  CTC[h  1ms^C}[
//	^C}[2  CTC[h 10ms^C}[
//	VA TX0,RX0 : IrDA MCP2122,TIR1000Ɛڑ
//			TX1,RX1 : USBW[(Hdq AE-CH340E)Ɛڑ 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
typedef uint8_t  byte;
typedef uint16_t word;
/*****  }N     *****/
#define DIMSIZ(a)   (sizeof(a)/sizeof(*a))  // zްԂ
#define nop()       asm volatile("nop;")    // NOPR[h
											// cli,seiinterrupt.h̒Œ`
//	I/O}N
#define RST_H		(PORTB |=  (1 << PB2))  // PB2 MCP2122,TIR1000 Zbgo
#define RST_L      	(PORTB &= ~(1 << PB2))  //
#define PA6_X		(PINA  |=  (1 << PA6))  // PA6 7pin eXgpX gO(!!!)
#define CK_JP1		((~PINA) & (1 << PA0))  // PA0 13pin on/off`FbN Lon1
#define PA7_H		(PORTA |=  (1 << PA7))  // PA7 (!!!) 6pin H/L
#define PA7_L      	(PORTA &= ~(1 << PA7))  //
//	f[^w
#define CR		0x0d		// A
#define LF		0x0a		// s
#define IrDA	0			// TX,RX ch0 : IrDA
#define USB		1			// TX,RX ch1 : USB
//	^Cg                      01234567890123456789012345678901234
const char msg_ttl0[] PROGMEM = "# FLUKE model 87IV IrDA com reader";
const char msg_ttl1[] PROGMEM = "# Op-key              (2022-11-15)";
const char msg_ttl2[] PROGMEM = "# 1 : Start measure";
const char msg_ttl3[] PROGMEM = "# 2 : Stop";
const char msg_ttl4[] PROGMEM = "# 0 : Clear cyc counter";
PGM_P msg_ttl[]={
	msg_ttl0, msg_ttl1, msg_ttl2, msg_ttl3, msg_ttl4,
};
//	IrDA`bv敪
const char msg_IRDA[]    PROGMEM = "# IrDA chip = ";
const char msg_MCP2122[] PROGMEM = "MCP2122\r\n";		// JP1 on
const char msg_TIR1000[] PROGMEM = "TIR1000\r\n";		// JP1 off
//	bZ[Wf[^
const char msg_start[]  PROGMEM = "# Start.\r\n";		// 1
const char msg_stop[]   PROGMEM = "# Stop.\r\n";		// 2
const char msg_clrcyc[] PROGMEM = "# Clr cyc.\r\n";		// 0
const char msg_clrstt[] PROGMEM = "# Clr & Start.\r\n";	// 0 runĂȂƂ
const char msg_err[]    PROGMEM = "# Err\r\n";

/********************************/
/*		^C}[				*/
/********************************/
//	^C}[f[^ (ȂC[vŏ)
volatile word tm_1ms;			// 1msŃ_EJEg
								// ʐM^CAEg`FbNɂgp
volatile word tm_usb;			// USBڑ҂^C}[
								// 1msŃ_EJEg
//	10ms : 100Hz
volatile byte cyc_10ms;			// cyc_cnt 1bvp 10msAbvJEg
volatile uint32_t cyc_1sec;		// cyc_cnt 1bvp 
volatile uint32_t cyc_cnt;		// TCNJE^
								// 1bƂcyc_1secRs[
volatile byte f_1sec;			// 1bo߃tO
/*****	^C}[s		*****/
//	1ms͌덷  	1ms肿Ƒ : 1000.0407Hz
//	10ms͐100Hz
void tmexc(void)
{
	if(TIFR1 & (1 << OCF1A)){			// 1mso
	  TIFR1 |= (1 << OCF1A);			// tONA
	  if(tm_1ms)		tm_1ms--;		// 1ms_EJEg
	  if(tm_usb)		tm_usb--;		// USB҂^C}[
	}
//	10msv:^C}[2
	if(TIFR2 & (1 << OCF2A)){			// 10mso
	  TIFR2 |= (1 << OCF2A);			// tONA
	  cyc_10ms++;						// +0.01b
	  if(cyc_10ms >= 100){				// 1bo?
		cyc_10ms = 0;
		if(f_1sec == 0){				// ȌĂ
		  cyc_cnt = cyc_1sec;			// ݕblcyc_cntɃRs[
		}
		cyc_1sec++;						// 1bi߂
		f_1sec = 1;						// 1boon
	  }
	}
}

/********************************/
/*		VAM			*/
/********************************/
//	ch0 : TX0,RX0 IrDA      9600BPS
//	ch1 : TX1,RX1 USB(PC)   9600BPS
/*****	Mf[^			******/
typedef struct{
	char 	*bff;				// Mf[^obt@̃AhX
	byte	size;				// Mobt@TCY
	volatile byte 	rdp;		// M ǂݏo|C^
	volatile byte 	wrp;		// M ݃|C^
	volatile byte 	cnt;		// M f[^
	volatile byte 	f;			// M stO f[^M1 0
}TX_DATS;
/*****	Mf[^			******/
typedef struct{
	char 	*bff;				// Mf[^obt@̃AhX
	byte	size;				// Mobt@TCY
	volatile byte 	rdp;		// M ǂݏo|C^
	volatile byte 	wrp;		// M ݃|C^
	volatile byte 	cnt;		// M f[^
}RX_DATS;
/*****	pf[^		*****/
TX_DATS		tx_data[2];			// 2ch̑Mf[^
RX_DATS		rx_data[2];			// 2ch̎Mf[^
//	Mobt@@prŃTCYς (255oCg܂)
char tx0_bff[8];				// FLUKEւ̑Mf[^
char rx0_bff[40];				// FLUKE̎Mf[^
char tx1_bff[32];				// USBւ̑Mf[^
char rx1_bff[8];				// USB̎Mf[^
//	f[^WX^
volatile byte *udr[] = {
	&UDR0,				// ch0
	&UDR1,				// ch1
};
//	Xe[^XWX^A
volatile byte *ucsra[] = {
	&UCSR0A,			// ch0
	&UCSR1A,			// ch1
};
//	Xe[^XWX^A
volatile byte *ucsrb[] = {
	&UCSR0B,			// ch0
	&UCSR1B,			// ch1
};
/*****	1sM		*****/
typedef struct{
	char 	*bff;				// Mf[^obt@̃AhX
	byte	size;				// Mobt@TCY
	byte 	cnt;				// Mf[^
	byte	ok;					// 1sMtO
}RX_STRS;
RX_STRS		rx_str[2];	// 2ch̕f[^
char rx0_str[40];		// IrDA M
char rx1_str[8];		// USB  M  gĂȂ

/*****	M`FbN	*****/
//	1:M 	0:MłȂ(obt@ς)
byte txx(byte ch)
{
byte cnt;
	cli();						// ֎~
	cnt = tx_data[ch].cnt;		// Mobt@f[^
	sei();
	if(cnt >= tx_data[ch].size)		return 0;	// Ms
	else							return 1;	// MOK
}

/*****	1o		*****/
//	obt@ɕĊ荞݂őMp
//	1 IrDAւ̑M̎IrDAM֎~
void tx(byte ch, char c)
{
char *p;
	while(txx(ch) == 0);		// Mok҂
//	֎~ɂăobt@ɏ
	cli();						// ֎~
	if(tx_data[ch].f == 0){					// ߂Ă̑M
		if(ch == IrDA){						// 1 IrDAȂ
			*ucsrb[ch] &= (~(1 << RXEN0));	// IrDA̎M֎~
			PA7_H;							// (!!!)
		}
		*udr[ch] = c;				// 1ڑM
		tx_data[ch].f = 1;			// MtO I
	}
	else{							// M
		p  = tx_data[ch].bff;		// obt@̐擪
		p += tx_data[ch].wrp;		// ݈ʒu
		*p = c;						// 1
		tx_data[ch].wrp++;			// |C^+1
		if(tx_data[ch].wrp >= tx_data[ch].size){	// ŏI?
		   tx_data[ch].wrp  = 0;					// 擪
		}
		tx_data[ch].cnt++;			// f[^+1
	}
	sei();							// L
}

/*****	CR,LFo		*****/
void txcrlf(byte ch)
{
	tx(ch, CR);
	tx(ch, LF);
}

/*****	o		*****/
/*		null܂ŏo		*/
void txstr(byte ch, char *p)
{
	while(*p){
		tx(ch, *p);
		p++;
	}
}

/***** wtްo	*****/
/*		printfƓ@\	()	*/
void txprintf(byte ch, char *s, ...)
{
	char bff[32];
	va_list vp;
	va_start(vp, s);
	vsnprintf(bff, sizeof(bff), s, vp);
	txstr(ch, bff);
	va_end(vp);
}

/*****	progmmemo	****/
void txstr_P(byte ch, const char *s)
{
char bff[40];
	strcpy_P(bff, s);				// 
	txstr(ch, bff);
}

/*****	^CgUSBɏo		*****/
void txttl(void)
{
byte i;
	txcrlf(USB);								// s
	for(i = 0; i < DIMSIZ(msg_ttl); i++){       // ^Cgf[^S
		txstr_P(USB, msg_ttl[i]);
		txcrlf(USB);
	}
//	IrDA`bv敪
	txstr_P(USB, msg_IRDA);		// "# IrDA chip = "
	if(CK_JP1)	txstr_P(USB, msg_MCP2122);		// JP1 on
	else		txstr_P(USB, msg_TIR1000);		// JP1 off
}

/*****	M		*****/
//	obt@Ƀf[^ΑMp
//	1 IrDAւ̑M̎IrDAMĊJ
void txint(byte ch)
{
char *p;
	if(tx_data[ch].cnt == 0){			// f[^
		if(ch == IrDA){					// 1 IrDAȂ
			*ucsrb[ch] |= (1 << RXEN0);	// MĊJ
			PA7_L;						// (!!!)
		}
		tx_data[ch].f = 0;			// MtO NA
	}
	else{							// f[^
		p  = tx_data[ch].bff;		// obt@̐擪
		p += tx_data[ch].rdp;		// ǂݏoʒu
		*udr[ch] = *p;				// 1M
		tx_data[ch].rdp++;			// |C^+1
		if(tx_data[ch].rdp >= tx_data[ch].size){	// ŏI?
			tx_data[ch].rdp  = 0;					// 擪
		}
		tx_data[ch].cnt--;				// f[^-1
	}
}

/*****	M荞		*****/
ISR(USART0_TX_vect)
{
	txint(IrDA);		// ch0 : IrDA
}
ISR(USART1_TX_vect)
{
	txint(USB);			// ch1 : USB
}

/*****	Mݏ	*****/
//	G[΃f[^̂Ă
//	Mobt@tł̂Ă
void rxint(byte ch)
{
byte d, s;			// f[^ƃXe[^X		
char *p;
	s = *ucsra[ch];			// Xe[^X
	d = *udr[ch];			// Mf[^
	if((s & 0b00011100) == 0){					// FE OR PE Ȃ
	  if(rx_data[ch].cnt < rx_data[ch].size){	// Mobt@̋ok
		p  = rx_data[ch].bff;		// obt@̐擪
		p += rx_data[ch].wrp;		// ݈ʒu
		*p = d;						// 1
		rx_data[ch].wrp++;			// |C^+1
		if(rx_data[ch].wrp >= rx_data[ch].size){	// ŏI?
			rx_data[ch].wrp  = 0;					// 擪
		}
		rx_data[ch].cnt++;			// f[^+1
	  }
	}
}

/*****	M荞		*****/
ISR(USART0_RX_vect)
{
	rxint(IrDA);		// ch0 : IrDA
}
ISR(USART1_RX_vect)
{
	rxint(USB);			// ch1 : USB
}

/*****	Mf[^邩`FbN	*****/
//	ret 1:Mf[^ 0:Ȃ
//	ch0:IrDA ch1:USB
byte rxx(byte ch)
{
byte d;
	cli();					// 񊄍֎~
	d = rx_data[ch].cnt;	// obt@f[^
	sei();
	if(d == 0)		return	0;		// f[^Ȃ
	else			return	1;		// 
}

/*****	1f[^M			*****/
//	obt@ǂݏo
//	ret  8bit R[h
//	ch   0:IrDA  1:USB
char rx(byte ch)
{
char *p;
char d;
	while(rxx(ch) == 0);		// Mf[^҂
	cli();						// ֎~
	p  = rx_data[ch].bff;
	p += rx_data[ch].rdp;		// Mobt@ǂݏoʒu
	d = *p;
	rx_data[ch].cnt--;			// f[^-1
	rx_data[ch].rdp++;			// |C^i߂
	if(rx_data[ch].rdp >= rx_data[ch].size){	// Ō܂ŗ
		rx_data[ch].rdp = 0;					// |C^擪
	}
	sei();						// ĊJ
	return	d;					// ǂݏof[^
}

/*****	1sMs		*****/
//	CR܂1[h
//	CRŕ̍ŌnullZbg.okI
//	isprintŕ\\`FbN
void rxstrexc(byte ch)
{
char *p;
char d;
	if((rxx(ch) != 0) &&       	 	// Mf[^
	   (rx_str[ch].ok == 0)){       // Of[^?
		d = rx(ch);         		// 1ǂݏo
		p  = rx_str[ch].bff;		// obt@̐擪
		p += rx_str[ch].cnt;		// 
		if(d == '\r'){              // CR?
			*p = '\0';     			// nullŌ
			rx_str[ch].ok  = 1;     // M
			rx_str[ch].cnt = 0;     // ͍ŏ
		}
		else if(d == '\b'){			// BS
			if(rx_str[ch].cnt != 0){
				rx_str[ch].cnt--;       // 1߂
			}
		}
		else{                       // 
			if((rx_str[ch].cnt < rx_str[ch].size) &&    // obt@TCY
			   (isprint(d))){			// \\0x20`0x7E
				*p = d;        			// obt@ɓ
				rx_str[ch].cnt++;       // 1i߂
			}
		}
	}
}

/*****	Mf[^NA		*****/
//	obt@̎Mƃ|C^NA
void clrrxdata(void)
{
byte i;
	cli();								// ֎~
	for(i = 0; i < 2; i++){				// IrDA,USB
		rx_data[i].cnt = 0;				// Mf[^
		rx_data[i].rdp = 0;
		rx_data[i].wrp = 0;
		rx_str[i].cnt  = 0;				// M
		rx_str[i].ok   = 0;
	}
	sei();
}

/********************************/
/*							*/
/********************************/
//	XTALg(MHz)ƃ{[[gAUBRRݒl̊֌W
//         4.9152 6.144 7.3728 9.216 9.8304 11.0592 14.7456 18.432
//	1200	  255   319    383   479    511     575     767    959
//	2400	  127   159    191   239    255     287     383    479
//	4800	   63    79     95   119    127     143     191    239
//	9600	   31    39     47    59     63      71      95    119
//	14.4k	    -     -     31    39      -      47      63     79
//	19.2k	   15    19     23    29     31      35      47     59
//	28.8k       -     -     15    19      -      23      31     39
//	38.4k	    7     9     11    14     15      17      23     29
//	57.6k	    -     -      7     9      -      11      15     19
//	76.8k	    3     4      5     -      7       8      11     14
//	115.2k	    -     -      3     4      -       5       7      9
/*****	I/OCjV	*****/
//	2chUART 荞݂
void initio(void)
{
	PUEA  = 0b00010101;     // pull up
	PORTA = 0b00100010;     // data
	DDRA  = 0b11101010;     // port in/outw
	//        |||||||+----  PA0  in  JP1 pull up (MCP2122,TIR1000)
	//        ||||||+-----  PA1  out TX0
	//        |||||+------  PA2  in  RX0
	//        ||||+-------  PA3  out TO2 OCR0B clko
	//        |||+--------  PA4  in  RX1
	//        ||+---------  PA5  out TX1
	//        |+----------  PA6  out (MOSI)
	//        +-----------  PA7  out -
	PUEB  = 0b00000100;     // pull up
	PORTB = 0b00000100;     // data
	DDRB  = 0b00000100;     // port in/outw
	//            |||+----  PB0  -   X1
	//            ||+-----  PB1  -   X2
	//            |+------  PB2  out MCP2122 /RST, TIR1000 Zbg H
	//            +-------  PB3  -   /RESET
//	^C}[0 : 153.6kHzNbN𔭐
	TCCR0A = 0b00010010;
	//         ||||  ++---- WGM01,00 CTC OCRA0
	//         ||++-------- COM0B RyA}b`ŃgO
	//         ++---------- COM0A
	TCCR0B = 0b00000001;
	//	       |+++--- CLK/1 4.9152MHz
	//	       +------ WGM02
	OCR0A = 16-1;		// 4.9152MHz / 16 / 2 = 153.6kHz
//	^C}[o̓s
	TOCPMCOE |= (1 << TOCC2OE);	// PA3=TO2 153.6kHz
//	^C}[1 : 1ms tO`FbNp
	TCCR1A = 0b00000000;
	//		   ||||  ++---- WGM CTC OCR1
	//		   ||++-------- COM1B
	//		   ++---------- COM1A
	TCCR1B = 0b00001001;
	//         || ||+++---- CS  4.9152MHz / 1
	//         || ++------- WGM CTC
	//         |+---------- ICES1
	//         +----------- ICNC1
	OCR1A  = 4915 - 1;		// 1000.0407Hz(1ms肿Ƒ)
//	^C}[1 : 10ms tO`FbNp
	TCCR2A = 0b00000000;
	//		   ||||  ++---- WGM CTC OCR1
	//		   ||++-------- COM2B
	//		   ++---------- COM2A
	TCCR2B = 0b00001010;
	//         || ||+++---- CS  4.9152MHz / 8 = 614.4kHz
	//         || ++------- WGM CTC
	//         |+---------- ICES2
	//         +----------- ICNC2
	OCR2A  = 6144 - 1;		// 100kHz ͂
//	VAM WX^ݒ
	UBRR0 = 31;			// 9600BPS  4915200/16/9600 -1
	UBRR1 = 31;			// 
	UCSR0B  = 0b11011000;				// ch0 M
	UCSR1B  = 0b11011000;				// ch1
	//		    |||||||+---- TXB0
	//		    ||||||+----- RXB8
	//		    |||||+------ UCSZ2
	//		    ||||+------- TXEN	M
	//		    |||+-------- RXEN	M
	//		    ||+--------- UDRIE
	//		    |+---------- TXCIE	M荞
	//		    +----------- RXCIE	M荞ݗL
	//	UCSRC͏l̂܂܂ 8bit + 1stop, np
//	VAM obt@̐ݒ  obt@̗prɂTCY
	tx_data[0].bff  = tx0_bff;			// obt@AhXƃTCYݒ
	tx_data[0].size = sizeof(tx0_bff);	// 0:IrDA
	tx_data[1].bff  = tx1_bff;			// 1:USB
	tx_data[1].size = sizeof(tx1_bff);
	rx_data[0].bff  = rx0_bff;
	rx_data[0].size = sizeof(rx0_bff);
	rx_data[1].bff  = rx1_bff;
	rx_data[1].size = sizeof(rx1_bff);
	rx_str[0].bff	= rx0_str;				// 1s񏈗f[^
	rx_str[0].size	= sizeof(rx0_str) - 1;  // null 1Ȃ
	rx_str[1].bff	= rx1_str;
	rx_str[1].size	= sizeof(rx1_str) - 1 ;
}
/********************************/
/*		C					*/
/********************************/
//	fW^[^̃f[^擾s敪
byte f_run;				// f[^擾s敪
						// 0 : ҋ@ USB"1"ŃX^[g
						// 1 : QMR}hs USB"0"Œ~
byte f_ack;				// ʐMԓ`FbN[h
						// 0 : R}hACK(0 or 1)`FbN
						//     "0"͗LR}ht
						// 1 : f[^҂
byte f_err;				// ^CAEgG[AACKG[
						// 1bo߂on  f[^okŃNA
						// 0:G[Ȃ 1:G[ 2:G[bZ[Wo͂
//	FLUKE 87䏈s敪
byte exc_j;				// s敪
//	S~f[^̂߂CRo
byte cr_cnt;			// Zbg̃S~菜
						// CR𑗂AԂĂM𖳎
/*****	MAIN	*****/
//	JP1ŃZbgԂς
//	on:MCP2122(kŃZbg)  off:TIR1000(HŃZbg)
//	MCP2122̏ꍇ,ZbguLHLHvƃgO
//	TIR1000́uHLvrun
int main(void)
{
char c;
	cli();						// 荞݋֎~
	initio();					// I/OA^C}[,UART
	sei();						// 荞݊Jn
	tm_usb = 3000;				// 3b^C}[ USBڑ̋N莞ԑ҂
//	loop
	while(1){
	  tmexc();					// ^C}[s
	  rxstrexc(IrDA);			// IrDA1sM
	  PA6_X;					// (!!!) PA6 7pin gO
//	s敪
	  switch(exc_j){
		case 0:		// MCP2122,TIR1000 Zbg  
		  if(CK_JP1){			// JP1 on:MCP2122
			RST_L;				// ΂炭Lێ
			exc_j++;
		  }
		  else{					// JP1 off:TIR1000 HŃZbg
			RST_H;				// ΂炭Hێ
			exc_j = 3;			// ^CAbvL
		  }
		  tm_1ms = 100;
		  break;
		case 1:		// MCP2122 ^CAbvŃZbg
		  if(tm_1ms == 0){
			RST_H;				// H
			tm_1ms = 100;
			exc_j++;
		  }
		  break;
		case 2:		// MCP2122 xZbg
		  if(tm_1ms == 0){
			RST_L;				// Zbg
			tm_1ms = 100;
			exc_j++;
		  }
		  break;
		case 3:		// Zbg
		  if(tm_1ms == 0){
		    if(CK_JP1){			// JP1 on:MCP2122
			  RST_H;			// HɂMCP2122 RUNԂ
			}
			else{				// JP1 off:TIR1000
			  RST_L;			// LɂTIR1000 RUNԂ
			}
			tm_1ms = 500;
			cr_cnt = 4;			// CR4񑗂ăS~𖳎
			exc_j++;
		  }
		  break;
		case 4:		// S~̂CR4񑗂
		  if(tm_1ms == 0){
		    if(cr_cnt == 0){				// 4񂨂
			   if(tm_usb == 0){				// USB̋N莞ԑ҂
				txttl();					// ^CgUSBɏo
				tm_1ms = 500;				// 0.5b
				exc_j++;					// IDM
			  }
			}
			else{							// 񐔂܂
				clrrxdata();				// Mf[^NA
				tx(IrDA, '\r');				// FLUKECR(G[R}hƂȂ)
				tx(USB,  '\r');				// USBւCRo
				tm_1ms = 500;				// 0.5b
				cr_cnt--;					// -1
			}
		  }
		  break;
		case 5:		// ҂āuIDvM
		  if(tm_1ms == 0){
			clrrxdata();			// Mf[^NA
			txstr(IrDA, "ID\r");	// uIDvR}h FLUKE֑o
			f_ack  = 0;				// ACK`FbN
			tm_1ms = 1000;			// ^CAEg1b
			exc_j++;
		  }
		  break;
		case 6:		// ID̉҂, eX^[@햼
		  if(tm_1ms == 0){				// ^CAEgX^[g҂
		    f_err = 1;					// G[
			f_run = 1;					// G[ǌvJn
			exc_j++;  
			break;
		  }
		  if(rx_str[IrDA].ok){			// eX^[IrDAł̉
			rx_str[IrDA].ok = 0;
			if(f_ack == 0){						// ACK=0, Err`FbN
			  if(strcmp(rx0_str, "0") == 0){	// "0" = ACK OK
			    tm_1ms = 1000;					// ^CAEg1b
			    f_ack = 1;						// IDf[^҂
			  }
			  else{							// ̓G[
		        f_err = 1;					// G[
			    f_run = 1;					// G[ǌvJn
			    exc_j++;					// Jn҂
			  }
		    }
			else{							// ack=1IDf[^҂
			  txstr(USB, "# ");				// eX^[@햼o
			  txstr(USB, rx0_str);
			  txcrlf(USB);
			  cyc_1sec = 0L;				// 1bvNA[
			  cyc_10ms = 0;					// 10ms^C}[NA
			  f_1sec = 0;					// 1bv
			  f_run  = 1;					// vJn
			  exc_j++;
			}
		  }
		  break;
		case 7:		// Jnw USB̎w߂`FbN
		  if(f_err == 1){					// G[?
			txstr_P(USB, msg_err);			// G[\
			f_err = 2;						// \
		  }
		  if(rxx(USB)){						// USB1M
			f_err = 0;						// G[Ȃ
			c = rx(USB);
			if(c == '2'){
				txstr_P(USB, msg_stop);		// "# Stop."
		  		f_run = 0;					// 2 : Stop v~
			}
			else if(c == '1'){				// 1 : Start vJn
			  if(f_run == 0){				// v~ĂƂL
				txstr_P(USB, msg_start);	// "# Start."
				f_1sec = 0;					// 1bv
				f_run  = 1;					// vJn
			  }
			}
			else if(c == '0'){				// 0 : TCNJE^NA
			  if(f_run == 0){				// ~
				f_run  = 1;					// vJn
				txstr_P(USB, msg_clrstt);	// "# Clr & Start."
			  }
			  else{							// łrunĂ
				txstr_P(USB, msg_clrcyc);	// "# Clr cyc."
			  }
			  cyc_1sec = 0L;				// 1bvNA[
			  cyc_10ms = 0;					// 10ms^C}[NA
			  f_1sec = 0;					// 1bv
			}
		  }
		  if(f_run){						// 蒆?
			if(f_1sec){						// 1bo?
			  txstr(IrDA, "QM\r");			// uQMvJn FLUKE֑o
			  f_ack  = 0;					// ACK`FbN
			  tm_1ms = 1000;				// ^CAEg1b
			  exc_j++;						// ҂
			}
		  }
		  break;
		case 8:		// FLUKE 87̉`FbN
		  if(tm_1ms == 0){					// ^CAEgX^[g҂
			if(f_err == 0)	f_err = 1;		// ͂߂ĂȂG[tOon
			f_1sec = 0;						// 1bv
			exc_j--;						// Jn֖߂
			break;
		  }
		  if(rx_str[IrDA].ok){				// FLUKE牞
			rx_str[IrDA].ok = 0;
			if(f_ack == 0){						// ACK=0, Err`FbN
			  if(strcmp(rx0_str, "0") == 0){	// "0" = ACK OK
			    tm_1ms = 1000;					// ^CAEg1b
				f_ack = 1;						// IDf[^҂
			  }
			  else{								// ̓G[
				if(f_err == 0)	f_err = 1;		// ͂߂ĂȂG[tOon
				f_1sec = 0;						// 1bv
			    exc_j--;						// Jn֖߂
			  }
			}
			else{								// ack=1őf[^M
			  if(strncmp(rx0_str, "QM,", 3) == 0){	// wb_[`FbNok
				txprintf(USB, "%5lu ", cyc_cnt);	// TCN 1bP
				tmexc();							// ^C}[s
				PA6_X;								// (!!!) PA6 7pin gO
				txstr(USB, rx0_str + 3);	// f[^ 擪"QM,"3USBɏo
				txcrlf(USB);				// s
				f_err  = 0;					// G[Ȃ
				f_1sec = 0;					// 1b
				exc_j--;					// Jn֖߂
			  }
			  else{							// wb_[G[
				if(f_err == 0)	f_err = 1;	// ͂߂ĂȂG[tOon
				f_1sec = 0;					// 1bv
				exc_j--;					// Jn֖߂
			  }
			}
		  }
		  break;
		}
    }
}

/*****	S~u		*****/
#if 0
//	GR[obN
if(rxx(USB))		tx(IrDA, rx(USB));	// USB  FLUKE
if(rxx(IrDA)){						// FLUKE  USB
	c = rx(IrDA);
	if(c == '\r')		txcrlf(USB);	// CR+LF
	else		  		tx(USB,  c);
}
break;
#endif

/*====	end of "fluke87_irda_tn841.c"	=====*/

